echo off

rem ---------------------------------------------------------------------------
rem input movie frame par seconds(fps)
set MOVIE_FPS=60

rem ---------------------------------------------------------------------------
echo Create folder for temporary files
mkdir %~dpn1tmp

rem ---------------------------------------------------------------------------
echo Turn input video into sequentially numbered frame images and store them in a temporary folder.
%~dp0ffmpeg.exe -i %1 %~dpn1tmp\%%05d.jpg

rem ---------------------------------------------------------------------------
echo Batch positioning of all frame images with StereoMovieAlign
%~dp0StereoMovieAlign.exe %~dpn1tmp

rem ---------------------------------------------------------------------------
echo Extracting audio files from input video
%~dp0ffmpeg.exe -i %1 %~dpn1.mp3

rem ---------------------------------------------------------------------------
echo Create a video by converting it to a format recognized as a 3D video by youtube.
%~dp0ffmpeg.exe -r %MOVIE_FPS% -start_number 00001 -y -i %~dpn1tmp\out\%%05d.jpg -r %MOVIE_FPS% -vcodec libx264 -x264opts "frame-packing=3" -pix_fmt yuv420p -vf scale=iw/2:ih -aspect 16:9 %~dpn1tmp.mp4
%~dp0ffmpeg.exe -i %~dpn1.mp3 -i %~dpn1tmp.mp4 -vcodec copy -acodec copy %~dpn1_youtube.mp4
del %~dpn1tmp.mp4

rem ---------------------------------------------------------------------------
echo Save video in full width SBS format
%~dp0ffmpeg.exe -r %MOVIE_FPS% -start_number 00001 -y -i %~dpn1tmp\out\%%05d.jpg -r %MOVIE_FPS% -vcodec libx264 -pix_fmt yuv420p %~dpn1tmp.mp4
%~dp0ffmpeg.exe -i %~dpn1.mp3 -i %~dpn1tmp.mp4 -vcodec copy -acodec copy %~dpn1_sbs.mp4
del %~dpn1tmp.mp4

rem ---------------------------------------------------------------------------
echo Save video in monochrome anaglyphs.
%~dp0ffmpeg.exe -r %MOVIE_FPS% -start_number 00001 -y -i %~dpn1tmp\out\%%05d.jpg -r %MOVIE_FPS% -vcodec libx264 -pix_fmt yuv420p -vf stereo3d=sbsl:arcg %~dpn1tmp.mp4
%~dp0ffmpeg.exe -i %~dpn1.mp3 -i %~dpn1tmp.mp4 -vcodec copy -acodec copy %~dpn1_gray_ana.mp4
del %~dpn1tmp.mp4

rem ---------------------------------------------------------------------------
echo Save video in color anaglyphs.
%~dp0ffmpeg.exe -r %MOVIE_FPS% -start_number 00001 -y -i %~dpn1tmp\out\%%05d.jpg -r %MOVIE_FPS% -vcodec libx264 -pix_fmt yuv420p -vf stereo3d=sbsl:arcc %~dpn1tmp.mp4
%~dp0ffmpeg.exe -i %~dpn1.mp3 -i %~dpn1tmp.mp4 -vcodec copy -acodec copy %~dpn1_col_ana.mp4
del %~dpn1tmp.mp4

rem ---------------------------------------------------------------------------
echo Save video in half-color anaglyphs.
%~dp0ffmpeg.exe -r %MOVIE_FPS% -start_number 00001 -y -i %~dpn1tmp\out\%%05d.jpg -r %MOVIE_FPS% -vcodec libx264 -pix_fmt yuv420p -vf stereo3d=sbsl:arch %~dpn1tmp.mp4
%~dp0ffmpeg.exe -i %~dpn1.mp3 -i %~dpn1tmp.mp4 -vcodec copy -acodec copy %~dpn1_hcol_ana.mp4
del %~dpn1tmp.mp4

rem ---------------------------------------------------------------------------
echo Save video in dubois anaglyphs.
%~dp0ffmpeg.exe -r %MOVIE_FPS% -start_number 00001 -y -i %~dpn1tmp\out\%%05d.jpg -r %MOVIE_FPS% -vcodec libx264 -pix_fmt yuv420p -vf stereo3d=sbsl:arcd %~dpn1tmp.mp4
%~dp0ffmpeg.exe -i %~dpn1.mp3 -i %~dpn1tmp.mp4 -vcodec copy -acodec copy %~dpn1_dubois.mp4
del %~dpn1tmp.mp4

rem ---------------------------------------------------------------------------
echo Delete temporary files.
del %~dpn1.mp3
echo Delete aligned frame image files.
del %~dpn1tmp\out\*.*
rmdir %~dpn1tmp\out
echo Delete original frame image files.
del %~dpn1tmp\*.*
rmdir %~dpn1tmp
pause
